swagger: '2.0'
info:
  title: Quickstart API
  version: "1.0.0"
  x-groupId: org.mycompany.kathra
paths:
  /helloWorld:
    get:
      summary: Returns a greeting.
      operationId: "sayHelloWorld"
      parameters:
        - name: name
          in: query
          type: string
          description: The name of the person to greet.
      responses:
        '200':
          description: Successful response.
          schema:
            $ref: "#/definitions/KathraResponse"
        default:
          description: Error response.
          schema:
            $ref: "#/definitions/KathraResponse"
  /uploadFile:
    post:
      summary: Saves a file.
      operationId: "saveFile"
      consumes:
        - multipart/form-data
      parameters:
        - in: formData
          name: file
          type: file
          description: The file to save.
      responses:
        200:
          description: Successful response.
          schema:
            $ref: "#/definitions/KathraResponse"
  /users:
    get:
      summary: "Retrieve users list"
      description: "Retrieve users list"
      operationId: "getUsers"
      responses:
        200:
          description: "successful operation"
          schema:
            type: "array"
            items:
              $ref: "#/definitions/User"
  /user:
    post:
      summary: "Create user"
      description: "This can only be done by the logged in user."
      operationId: "createUser"
      produces:
      - "application/json"
      parameters:
      - in: "body"
        name: "body"
        description: "Created user object"
        required: true
        schema:
          $ref: "#/definitions/User"
      responses:
        '200':
          description: Successful response.
          schema:
            $ref: "#/definitions/KathraResponse"
        default:
          description: Error response.
          schema:
            $ref: "#/definitions/KathraResponse"
  /user/createWithList:
    post:
      summary: "Creates list of users with given input array"
      description: ""
      operationId: "createUsersWithListInput"
      produces:
      - "application/json"
      parameters:
      - in: "body"
        name: "body"
        description: "List of user object"
        required: true
        schema:
          type: "array"
          items:
            $ref: "#/definitions/User"
      responses:
        '200':
          description: Successful response.
          schema:
            $ref: "#/definitions/KathraResponse"
        default:
          description: Error response.
          schema:
            $ref: "#/definitions/KathraResponse"
  /user/login:
    get:
      summary: "Logs user into the system"
      description: ""
      operationId: "loginUser"
      produces:
      - "application/json"
      parameters:
      - name: "username"
        in: "query"
        description: "The user name for login"
        required: true
        type: "string"
      - name: "password"
        in: "query"
        description: "The password for login in clear text"
        required: true
        type: "string"
      responses:
        200:
          description: "successful operation"
          schema:
            type: "string"
        400:
          description: "Invalid username/password supplied"
  /user/logout:
    get:
      summary: "Logs out current logged in user session"
      description: ""
      operationId: "logoutUser"
      produces:
      - "application/json"
      parameters: []
      responses:
        '200':
          description: Successful response.
          schema:
            $ref: "#/definitions/KathraResponse"
        default:
          description: Error response.
          schema:
            $ref: "#/definitions/KathraResponse"
  /user/{username}:
    get:
      summary: "Get user by user name"
      description: ""
      operationId: "getUserByName"
      produces:
      - "application/json"
      parameters:
      - name: "username"
        in: "path"
        description: "The name that needs to be fetched. Use user1 for testing. "
        required: true
        type: "string"
      responses:
        200:
          description: "successful operation"
          schema:
            $ref: "#/definitions/User"
        400:
          description: "Invalid username supplied"
        404:
          description: "User not found"
    put:
      summary: "Update user"
      description: "This can only be done by the logged in user."
      operationId: "updateUser"
      produces:
      - "application/json"
      parameters:
      - name: "username"
        in: "path"
        description: "name that need to be updated"
        required: true
        type: "string"
      - in: "body"
        name: "body"
        description: "Updated user object"
        required: true
        schema:
          $ref: "#/definitions/User"
      responses:
        400:
          description: "Invalid user supplied"
        404:
          description: "User not found"
    delete:
      summary: "Delete user"
      description: "This can only be done by the logged in user."
      operationId: "deleteUser"
      produces:
      - "application/json"
      parameters:
      - name: "username"
        in: "path"
        description: "The name that needs to be deleted"
        required: true
        type: "string"
      responses:
        400:
          description: "Invalid username supplied"
        404:
          description: "User not found"
definitions:
  KathraResponse:
    type: "object"
    properties:
      message:
        description: Response's message
        type: "string"
  User:
    type: "object"
    properties:
      id:
        type: "integer"
        format: "int64"
      username:
        type: "string"
      firstName:
        type: "string"
      lastName:
        type: "string"
      email:
        type: "string"
      password:
        type: "string"
      phone:
        type: "string"
      userStatus:
        type: "integer"
        format: "int32"
        description: "User Status"
      
